<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® NonCommercial, 7.4 of December 5, 2005 on December 8, 2006 at 10:49:46 pm</time-stamp>


<name-space>
<name>Dricol</name>
<environment>CormasNS.Models</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			private CormasNS.Kernel.*
			</imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</name-space>


<class>
<name>Beach</name>
<environment>CormasNS.Models.Dricol</environment>
<super>CormasNS.Kernel.SpatialEntityAggregate</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>nbWoods width height </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Dricol.Beach</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Dricol</package>
</attributes>
</shared-variable>

<methods>
<class-id>CormasNS.Models.Dricol.Beach</class-id> <category>control</category>

<body package="Dricol" selector="initWoods">initWoods
| newWood |
	self nbWoods timesRepeat: 
			[newWood := Wood new.
			newWood isMovedTo: (Cormas selectRandomlyFrom: self components)]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Beach</class-id> <category>accessing</category>

<body package="Dricol" selector="height">height
	"Getter accessor with default value = 30 "
	^height ifNil:[height := 30]</body>

<body package="Dricol" selector="height:">height: anObject 
	height := anObject</body>

<body package="Dricol" selector="nbWoods">nbWoods
	"Getter accessor with default value = 300 "
	^nbWoods ifNil:[nbWoods := 300]</body>

<body package="Dricol" selector="nbWoods:">nbWoods: anObject 
	nbWoods := anObject</body>

<body package="Dricol" selector="width">width
	"Getter accessor with default value = 30 "
	^width ifNil:[width := 30]</body>

<body package="Dricol" selector="width:">width: anObject 
	width := anObject</body>
</methods>


<class>
<name>Wood</name>
<environment>CormasNS.Models.Dricol</environment>
<super>CormasNS.Kernel.ObjectLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Dricol.Wood</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Dricol</package>
</attributes>
</shared-variable>

<methods>
<class-id>CormasNS.Models.Dricol.Wood</class-id> <category>pov</category>

<body package="Dricol" selector="pov">pov
"return a symbol or a ColorValue"
^self class name</body>
</methods>


<class>
<name>Dricol</name>
<environment>CormasNS.Models.Dricol</environment>
<super>CormasNS.Kernel.CormasModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>theCollectors nbCollectors theAttitudes theDisrespectfuls theRespectfuls theWoods theBeachPortions thePiles theBaskets theBeachs nbTimeStepsUntilCompleteAdoption </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Dricol.Dricol class</class-id> <category>description</category>

<body package="Dricol" selector="lastUpdate">lastUpdate
^ 'December 8, 2006'	</body>

<body package="Dricol" selector="version">version
^ 'DricolJune2005.st'	</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Dricol.Dricol</class-id> <category>init</category>

<body package="Dricol" selector="init">init
	self initBeach.
	self initCollectors</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Dricol</class-id> <category>instance-creation</category>

<body package="Dricol" selector="initBeach">initBeach
	| beach |
	beach := Beach new: self spaceModel.
	self spaceModel 
		initializeRegularX: beach width
		Y: beach height
		shape: #squared
		nbNeighbours: #eight
		boundaries: #closed
		delimiter: true.
	beach addComponents: self theBeachPortions.
	beach initWoods</body>

<body package="Dricol" selector="initCollectors">initCollectors
	super initAgents.
	self setRandomlyLocatedAloneAgents: Collector n: self nbCollectors.
	self nbTimeStepsUntilCompleteAdoption: 0</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Dricol</class-id> <category>accessing</category>

<body package="Dricol" selector="nbCollectors">nbCollectors
	"Getter accessor with default value = 10 "
	nbCollectors isNil ifTrue:[nbCollectors := 10]. 
	
	^nbCollectors</body>

<body package="Dricol" selector="nbCollectors:">nbCollectors: anObject 
	nbCollectors := anObject</body>

<body package="Dricol" selector="nbTimeStepsUntilCompleteAdoption:">nbTimeStepsUntilCompleteAdoption: anObject 
	nbTimeStepsUntilCompleteAdoption := anObject</body>

<body package="Dricol" selector="theAttitudes">theAttitudes
^theAttitudes ifNil:[theAttitudes := IndexedSet new]</body>

<body package="Dricol" selector="theAttitudes:">theAttitudes: x
theAttitudes := x</body>

<body package="Dricol" selector="theBaskets">theBaskets
^theBaskets ifNil:[theBaskets := IndexedSet new]</body>

<body package="Dricol" selector="theBaskets:">theBaskets: x
theBaskets := x</body>

<body package="Dricol" selector="theBeachPortions">theBeachPortions
^theBeachPortions ifNil:[theBeachPortions := IndexedSet new]</body>

<body package="Dricol" selector="theBeachPortions:">theBeachPortions: x
theBeachPortions := x</body>

<body package="Dricol" selector="theBeachs">theBeachs
^theBeachs ifNil:[theBeachs := IndexedSet new]</body>

<body package="Dricol" selector="theBeachs:">theBeachs: x
theBeachs := x</body>

<body package="Dricol" selector="theCollectors">theCollectors
^theCollectors ifNil:[theCollectors := IndexedSet new]</body>

<body package="Dricol" selector="theCollectors:">theCollectors: x
theCollectors := x</body>

<body package="Dricol" selector="theDisrespectfuls">theDisrespectfuls
^theDisrespectfuls ifNil:[theDisrespectfuls := IndexedSet new]</body>

<body package="Dricol" selector="theDisrespectfuls:">theDisrespectfuls: x
theDisrespectfuls := x</body>

<body package="Dricol" selector="thePiles">thePiles
^thePiles ifNil:[thePiles := IndexedSet new]</body>

<body package="Dricol" selector="thePiles:">thePiles: x
thePiles := x</body>

<body package="Dricol" selector="theRespectfuls">theRespectfuls
^theRespectfuls ifNil:[theRespectfuls := IndexedSet new]</body>

<body package="Dricol" selector="theRespectfuls:">theRespectfuls: x
theRespectfuls := x</body>

<body package="Dricol" selector="theWoods">theWoods
^theWoods ifNil:[theWoods := IndexedSet new]</body>

<body package="Dricol" selector="theWoods:">theWoods: x
theWoods := x</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Dricol</class-id> <category>probes</category>

<body package="Dricol" selector="nbTimeStepsUntilCompleteAdoption">nbTimeStepsUntilCompleteAdoption
	^nbTimeStepsUntilCompleteAdoption</body>

<body package="Dricol" selector="proportionRespect">proportionRespect
	| respectfulCollectors |
	respectfulCollectors := self theCollectors 
				select: [:aCollector | aCollector attitude class = Respectful].
	^(respectfulCollectors size / self theCollectors size) asFloat</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Dricol</class-id> <category>control</category>

<body package="Dricol" selector="step:">step: t 
	self stepAgents</body>

<body package="Dricol" selector="stepUntilCompleteAdoption:">stepUntilCompleteAdoption: t 
	| realTimeStep |
	realTimeStep := 0.	
	[self theCollectors 
		contains: [:aCollector | aCollector attitude class name = #Disrespectful]] 
			whileTrue: 
				[realTimeStep := realTimeStep + 1.
				self step: t].
	self nbTimeStepsUntilCompleteAdoption: realTimeStep</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Dricol</class-id> <category>interface</category>

<body package="Dricol" selector="driftwoodDensityClasses">driftwoodDensityClasses
	| nbClasses densityClasses nbWoodyBeachPortions densityClass |
	nbClasses := 15.
	densityClasses := Array new: nbClasses withAll: 0.
	nbWoodyBeachPortions := 0.
	self theBeachPortions do: 
			[:aBP | 
			densityClass := nbClasses min: (aBP myOccupants: #Wood) size.
			densityClass isZero 
				ifFalse: 
					[nbWoodyBeachPortions := nbWoodyBeachPortions + 1.
					densityClasses at: densityClass put: (densityClasses at: densityClass) + 1]].
	densityClasses := densityClasses 
				collect: [:anInteger | (anInteger / nbWoodyBeachPortions) asFloat].
	^densityClasses</body>
</methods>


<class>
<name>Attitude</name>
<environment>CormasNS.Models.Dricol</environment>
<super>CormasNS.Kernel.PassiveObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>threshold myCollector </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Dricol.Attitude</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Dricol</package>
</attributes>
</shared-variable>

<methods>
<class-id>CormasNS.Models.Dricol.Attitude</class-id> <category>controlling</category>

<body package="Dricol" selector="isAppliedTo:">isAppliedTo: aCollector 
	self myCollector: aCollector</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Attitude</class-id> <category>displaying</category>

<body package="Dricol" selector="displayWatch:">displayWatch: previousBeachPortion</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Attitude</class-id> <category>accessing</category>

<body package="Dricol" selector="myCollector">myCollector
	^myCollector</body>

<body package="Dricol" selector="myCollector:">myCollector: anObject
	myCollector := anObject</body>

<body package="Dricol" selector="pileSize">pileSize
	^self myCollector pile size</body>

<body package="Dricol" selector="threshold">threshold
	threshold ifNil: [threshold := 15].
	^threshold</body>

<body package="Dricol" selector="threshold:">threshold: anObject
	threshold := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Attitude</class-id> <category>reasoning</category>

<body package="Dricol" selector="freeDestinations">freeDestinations
	^self myCollector patch neighbourhoodAndSelf 
		reject: [:aBeachPortion | aBeachPortion containsPile]</body>
</methods>


<class>
<name>Collector</name>
<environment>CormasNS.Models.Dricol</environment>
<super>CormasNS.Kernel.AgentLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>pile basket attitude </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Dricol.Collector</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Dricol</package>
</attributes>
</shared-variable>

<methods>
<class-id>CormasNS.Models.Dricol.Collector</class-id> <category>accessing</category>

<body package="Dricol" selector="attitude">attitude
	^attitude</body>

<body package="Dricol" selector="attitude:">attitude: anAttitude 
	attitude := anAttitude.
	anAttitude isAppliedTo: self</body>

<body package="Dricol" selector="basket">basket
	"Getter accessor without default value "
	^basket</body>

<body package="Dricol" selector="basket:">basket: anObject 
	basket := anObject</body>

<body package="Dricol" selector="pile">pile
	^pile</body>

<body package="Dricol" selector="pile:">pile: anObject
	pile := anObject</body>

<body package="Dricol" selector="pileLocation">pileLocation
	^self pile patch</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Collector</class-id> <category>init</category>

<body package="Dricol" selector="init">init
	self attitude: Disrespectful new.
	self basket: Basket new init</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Collector</class-id> <category>moving</category>

<body package="Dricol" selector="elementWithHighestValue:from:">elementWithHighestValue: aSymbol from: aList 
	| sortedList |
	(aList contains: [:x | ((x perform: aSymbol) respondsTo: #&gt;) not]) 
		ifTrue: [self halt].
	sortedList := aList 
				asSortedCollection: [:x1 :x2 | (x1 perform: aSymbol) &gt; (x2 perform: aSymbol)].
	sortedList := sortedList 
				select: [:x | (x perform: aSymbol) = (sortedList first perform: aSymbol)].
	^Cormas selectRandomlyFrom: sortedList</body>

<body package="Dricol" selector="moveTo:">moveTo: aBeachPortion 
	| previousBeachPortion |
	previousBeachPortion := self patch.
	super moveTo: aBeachPortion.
	self attitude displayWatch: previousBeachPortion</body>

<body package="Dricol" selector="moveTowards:">moveTowards: aSpatialEntity 
	| sortedDestinations |
	self patch = aSpatialEntity 
		ifFalse: 
			[sortedDestinations := self patch neighbourhood asSortedCollection: 
							[:aBeachPortion1 :aBeachPortion2 | 
							(aBeachPortion1 distCell: aSpatialEntity) 
								&lt; (aBeachPortion2 distCell: aSpatialEntity)].
			self moveTo: sortedDestinations first]</body>

<body package="Dricol" selector="searchAndMove">searchAndMove
	| destinations |
	destinations := self attitude freeDestinations.
	destinations isEmpty ifTrue: [self halt].
	self moveTo: (self elementWithHighestValue: #nbWoods from: destinations)</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Collector</class-id> <category>pov</category>

<body package="Dricol" selector="povAttitude">povAttitude
	(self attitude class name = #Disrespectful and: [self patch isWatched]) 
		ifTrue: [^#DisrespectfulWatched].
	^self attitude class name</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Collector</class-id> <category>probes</category>

<body package="Dricol" selector="pileSize">pileSize
	^self pile size</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Collector</class-id> <category>controlling</category>

<body package="Dricol" selector="collectOnePieceOfWood">collectOnePieceOfWood
	| collectedWood |
	collectedWood := Cormas selectRandomlyFrom: self patch woods.
	collectedWood leave.
	self basket woods add: collectedWood</body>

<body package="Dricol" selector="collectSomeWood">collectSomeWood
	| nbWoodsToBeCollected |
	self patch nbWoods isZero 
		ifFalse: 
			[nbWoodsToBeCollected := self patch nbWoods 
						min: self basket remainingCapacity.
			nbWoodsToBeCollected timesRepeat: [self collectOnePieceOfWood]]</body>

<body package="Dricol" selector="createPile">createPile
	self pile: Pile new.
	self pile isMovedTo: self patch</body>

<body package="Dricol" selector="step">step
	self basket isFull 
		ifTrue: 
			[self pile isNil 
				ifTrue: 
					[self createPile.
					self basket isEmptiedIn: self patch.
					self attitude evaluate]
				ifFalse: 
					[self moveTowards: self pileLocation.
					self patch = self pileLocation 
						ifTrue: 
							[self basket isEmptiedIn: self patch.
							self attitude evaluate]]]
		ifFalse: 
			[self searchAndMove.
			self collectSomeWood]</body>
</methods>


<class>
<name>Disrespectful</name>
<environment>CormasNS.Models.Dricol</environment>
<super>CormasNS.Models.Dricol.Attitude</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars>visibilityRange </class-inst-vars>
<imports></imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Dricol.Disrespectful</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Dricol</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Dricol.Disrespectful class</class-id> <category>accessing</category>

<body package="Dricol" selector="visibilityRange">visibilityRange
	"Getter accessor with default value = 3 "
	visibilityRange isNil ifTrue:[visibilityRange := 3]. 
	
	^visibilityRange</body>

<body package="Dricol" selector="visibilityRange:">visibilityRange: anObject 
	visibilityRange := anObject</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Dricol.Disrespectful</class-id> <category>testing</category>

<body package="Dricol" selector="isWatched">isWatched
	^(self myCollector 
		perceivedSimilarAgentsWithinRange: self class visibilityRange) 
			contains: [:aCollector | aCollector attitude class = Respectful]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Disrespectful</class-id> <category>reasoning</category>

<body package="Dricol" selector="evaluate">evaluate
	self pileSize &gt;= self threshold 
		ifTrue: [self myCollector attitude: Respectful new]</body>

<body package="Dricol" selector="freeDestinations">freeDestinations
	^self isWatched 
		ifTrue: [super freeDestinations]
		ifFalse: 
			[self myCollector patch neighbourhoodAndSelf reject: 
					[:aBeachPortion | 
					self myCollector pile notNil
						and: [aBeachPortion = self myCollector pileLocation]]]</body>
</methods>


<class>
<name>BeachPortion</name>
<environment>CormasNS.Models.Dricol</environment>
<super>CormasNS.Kernel.SpatialEntityElement</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Dricol.BeachPortion</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Dricol</package>
</attributes>
</shared-variable>

<methods>
<class-id>CormasNS.Models.Dricol.BeachPortion</class-id> <category>testing</category>

<body package="Dricol" selector="containsPile">containsPile
	^(self myOccupants: #Pile) isEmpty not</body>

<body package="Dricol" selector="isWatched">isWatched
	^(self recursiveNeighbourhood: Disrespectful visibilityRange) contains: 
			[:aBeachPortion | 
			(aBeachPortion myOccupants: #Collector) 
				contains: [:aCollector | aCollector attitude class name = #Respectful]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.BeachPortion</class-id> <category>accessing</category>

<body package="Dricol" selector="nbWoods">nbWoods
	^(self myOccupants: #Wood) size</body>

<body package="Dricol" selector="neighbourWithHighestValue:">neighbourWithHighestValue: aSelector</body>

<body package="Dricol" selector="woods">woods
	^self myOccupants: #Wood</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.BeachPortion</class-id> <category>pov</category>

<body package="Dricol" selector="pov">pov
	^#sand</body>

<body package="Dricol" selector="povWatch">povWatch
| baseColor |
	^self isWatched 
		ifTrue: 
			[baseColor := self class colorsDict at: #sand.
			ColorValue 
				hue: baseColor hue
				saturation: baseColor saturation
				brightness: baseColor brightness * 0.9]
		ifFalse: [self pov]</body>
</methods>


<class>
<name>Respectful</name>
<environment>CormasNS.Models.Dricol</environment>
<super>CormasNS.Models.Dricol.Attitude</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Dricol.Respectful</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Dricol</package>
</attributes>
</shared-variable>

<methods>
<class-id>CormasNS.Models.Dricol.Respectful</class-id> <category>reasoning</category>

<body package="Dricol" selector="evaluate">evaluate
	self pileSize &lt; self threshold 
		ifTrue: [self myCollector attitude: Disrespectful new]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Respectful</class-id> <category>displaying</category>

<body package="Dricol" selector="displayWatch:">displayWatch: previousBeachPortion 
| oldOnes newOnes changedOnes |
	oldOnes := (previousBeachPortion recursiveNeighbourhood: Disrespectful visibilityRange) asSet.
	newOnes := (self myCollector patch recursiveNeighbourhood: Disrespectful visibilityRange) asSet.
	changedOnes := Set new.
	changedOnes addAll: oldOnes; addAll: newOnes.
	changedOnes do: [:aBeachPortion | aBeachPortion show]</body>
</methods>


<class>
<name>Pile</name>
<environment>CormasNS.Models.Dricol</environment>
<super>CormasNS.Kernel.ObjectLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Dricol.Pile</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Dricol</package>
</attributes>
</shared-variable>

<methods>
<class-id>CormasNS.Models.Dricol.Pile</class-id> <category>pov</category>

<body package="Dricol" selector="pov">pov
"#Pile"
^self class name</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Pile</class-id> <category>accessing</category>

<body package="Dricol" selector="size">size
	^(self patch myOccupants: #Wood) size</body>
</methods>


<class>
<name>Basket</name>
<environment>CormasNS.Models.Dricol</environment>
<super>CormasNS.Kernel.PassiveObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>capacity woods </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>DricolCategory</category>
<attributes>
<package>Dricol</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Dricol.Basket</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Dricol</package>
</attributes>
</shared-variable>

<methods>
<class-id>CormasNS.Models.Dricol.Basket</class-id> <category>testing</category>

<body package="Dricol" selector="isFull">isFull
	^self woods size = self capacity</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Basket</class-id> <category>accessing</category>

<body package="Dricol" selector="capacity">capacity
	"Getter accessor with default value = 10 "
	capacity isNil ifTrue:[capacity := 10]. 
	
	^capacity</body>

<body package="Dricol" selector="capacity:">capacity: anObject 
	capacity := anObject</body>

<body package="Dricol" selector="remainingCapacity">remainingCapacity
	^self capacity - self woods size</body>

<body package="Dricol" selector="woods">woods
	"Getter accessor with default value = empty orderedCollection "
	^woods ifNil:[woods := OrderedCollection new]</body>

<body package="Dricol" selector="woods:">woods: anObject 
	woods := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Dricol.Basket</class-id> <category>control</category>

<body package="Dricol" selector="isEmptiedIn:">isEmptiedIn: aBeachPortion 
	self woods do: [:aWood | aWood isMovedTo: aBeachPortion].
	self woods: OrderedCollection new</body>
</methods>



</st-source>
